class BaseChannel(object):
    def __init__(self):
        self.PTR = None
    def communicate(self, transmission_and_reception):
        nodes_num = len(transmission_and_reception)
        records = [None for i in range(nodes_num)]
        ra = [None for i in range(nodes_num)]
        channels_num = len(transmission_and_reception[0])
        channels = [{
            'senders': [],
            'receivers': []
        } for i in range(channels_num)]
        for j in range(nodes_num):
            node_action = transmission_and_reception[j]
            for i in range(channels_num):
                if node_action[i] == None:
                    continue
                elif node_action[i][0] == -1:
                    channels[i]['receivers'].append(j)
                    records[j] = (-1, [])
                elif node_action[i][0] == 1:
                    channels[i]['senders'].append(node_action[i][1:])
                    records[j] = (1, [])

        for i in range(channels_num):
            senders = channels[i]['senders']
            receivers = channels[i]['receivers']
            for sender in senders:
                if sender[1] in receivers:
                    if records[sender[1]] is not None:
                        records[sender[1]][1].append(sender[0])

        for i in range(nodes_num):
            record = records[i]
            if record is not None and record[0] == -1:
                if len(record[1]) == 1:
                    ra[i] = record[1][0]
                    ra[record[1][0]] = i
        return ra

