import pandas as pd
import random
import SelectCH2 as sch2
import f3 as dn_cur_nbr
import RLBR1
import reliability1 as re
class imlearning:
    _qmatrix = None
    _learn_rate = None
    _d_factor = None
    def __init__(self,p_states,p_actions,initial_reward,learning_rate, discount_factor):
        # Initialize the matrix with Q-values
        init_data = [[float(initial_reward) for _ in p_states]
                     for _ in p_actions]
        self._qmatrix = pd.DataFrame(data=init_data, index=p_actions, columns=p_states)
        # Save the parameters
        self._learn_rate = learning_rate
        self._d_factor = discount_factor
    def get_best_action(self, state):
        # Return the action (index) with maximum Q-value
        return self._qmatrix[[state]].idxmax().iloc[0]
    def update_model(self, state, action, reward, next_state):
        # Update q_value for a state-action pair Q(s,a):
        h_cur=[];
        tt=[];
        k=[];
        n=[]
        nm=[]
        q_old = self._qmatrix.ix[action, state]
        R = self._qmatrix.ix[self.get_best_action(next_state), next_state]
        Q_cur_nbr=[]
        Q_cur=[]
        h_nbr=[];
        ECH_res=RLBR1.select(next_state,nm,1)
        pp=random.uniform(0,1)
        for j in range(next_state):
            node_action=[]
            for i in range(tt):
                if node_action[i] == None:
                    continue
                    Q_cur_nbr.append(node_action[i][1:])
        r = reward
        alpha = self._learn_rate
        ECH_nbr=sch2.select(tt,self.qmatrix,self._d_factor,r)
        ECH_nbr=ECH_res
       #gamma = self._d_factor
       #new_q_sa = q_sa + alpha * (r + gamma * max_q_sa_next - q_sa)
        R=(ECH_nbr*Q_cur_nbr)/(dn_cur_nbr.ic_distance(k, n)*ECH_nbr);
        Q_cur_nbr = (1-alpha)*q_old+alpha*(R+Q_cur_nbr);
        self._qmatrix.set_value(action, state, Q_cur_nbr)
        sch2.select(tt,self.qmatrix,self._d_factor,r)
        if pp>=re.BaseChannel:
           R=(ECH_nbr*Q_cur_nbr*Q_cur)/(dn_cur_nbr.ic_distance(k, n)*ECH_nbr);
           new_q_sa = (1-alpha)*q_old+alpha*(R+Q_cur_nbr);
           self._qmatrix.set_value(action, state, new_q_sa)
           sch2.select(tt,self.qmatrix,self._d_factor,r)
        for j in range(R):
            h_nbr.append(next_state[1])
            if len(h_nbr) > 0:
                maxx=max(Q_cur_nbr)
                Q_cur=maxx
                h_cur=h_nbr+1
        if h_cur>maxx:
           R=(ECH_nbr*Q_cur_nbr*Q_cur)/(dn_cur_nbr.ic_distance(k, n)*ECH_nbr);
           new_q_sa = (1-alpha)*q_old+alpha*(R+Q_cur_nbr);
           self._qmatrix.set_value(action, state, new_q_sa)
           sch2.select(tt,self.qmatrix,self._d_factor,r)

